#
#
#
ia.average <- function(img,
                       widthx,
                       widthy,
                       norm = TRUE)
{
  if(!is.animage(img))
    stop("img must be an animage")

  if((img@storage == "integer") || (img@storage == "real")) {
    res <- .Call("aniAverage",
                 img,
                 as.integer(widthx),
                 as.integer(widthy),
                 if(norm) 1L else 0L,
                 PACKAGE="AnImAl")
  } else {
    stop("unsupported image type")
  }
  
  if(is.call(updatedHistory <- ia.updatedHistory(match.call()))) {
    res@history  <- updatedHistory
    res@document <- TRUE
  } else {
    res@history  <- call("<undef>")
    res@document <- FALSE
  }

  res
}
