ia.zoom <- function(plotfunc, extent, ia.zdev = dev.cur(), level = 0) {

  if(level == 0) {
	print("Zoom in:       Left click two corners", quote=FALSE)
	print("Accept detail: Right click", quote=FALSE)
	print("Reject detail: Left click outside the plot region", quote=FALSE)
  }
  
  ia.zdev
    
  X11()

  lim       <- extent
  lim.stack <- lim
  lim.depth <- 1
  lim.cur   <- 1
 
  res <- ia.get(plotfunc(NULL), extent)

  repeat{
      
    par(bg="lightgray")
      
    plotfunc(lim)
        
    ext <- par()$usr

    l <- locator(1)

    if(is.null(l)) {
      break
    }
        
    if((l$x < ext[1]) ||
       (l$x > ext[2]) ||
       (l$y > ext[4]) ||
       (l$y < ext[3])) {
      res <- NULL
      break
    }
    else
      l1 <- l
        
    l <- locator(1)

    if(is.null(l)) {
      res <- ia.get(plotfunc(NULL), extent)
      break
    }
      
    if((l$x < ext[1]) ||
       (l$x > ext[2]) ||
       (l$y > ext[4]) ||
       (l$y < ext[3])) {
      res <- NULL
      break
    }
    else
      l2 <- l
        
    #
    # compute the animask from the two selected
    # corners
    #

    x0 <- min(l1$x, l2$x) + extent@x
    y0 <- (extent@h -  max(l1$y, l2$y)) + extent@y
    dx <- max(l1$x, l2$x) - min(l1$x, l2$x)
    dy <- max(l1$y, l2$y) - min(l1$y, l2$y)
        
    m <-   animask(as.integer(x0),
                   as.integer(y0),
                   as.integer(dx),
                   as.integer(dy))
  
    #
    # and activate it
    #
    res <- ia.zoom(plotfunc, m, level = level+1)
    if(!is.null(res))
      break
  }
  dev.off()
  if(ia.zdev > 1)
    dev.set(which=ia.zdev)
  res
}

ia.show <- function(img, ...) {

  extras <- match.call(expand.dots = FALSE)$...

  if(is.null(extras$interactive)) {
    if(is.animage(img)) {
      plot(pixmapGrey(img@data), ...)
    } else {
      plot(pixmapRGB(abind(img[[1]]@data,
                           img[[2]]@data,
                           img[[3]]@data, rev.along=0)),
           ...)
    }
  } else {
    if(is.list(img))
      extent <- ia.mask(img[[1]])
    else
      extent <- ia.mask(img)

    plotfunc <- function(lim){
      if(is.null(lim)) {
        img
      } else {
        
        ia.show(ia.get(img, lim))
      
        axis(1,c(0.5, lim@w-0.5), labels=c(lim@x, lim@x+lim@w-1))
        axis(2,c(0.5, lim@h-0.5), labels=c(lim@y+lim@h-1, lim@y))
      
      }
    }

    ia.zoom(plotfunc, extent)
  }
}

ia.show <- function(img, interactive = FALSE, ...) {

  if(!interactive) {
    if(is.animage(img)) {
      plot(pixmapGrey(img@data), ...)
      lim <- ia.mask(img)
      
    } else {
      plot(pixmapRGB(abind(img[[1]]@data,
                           img[[2]]@data,
                           img[[3]]@data, rev.along=0)),
           ...)
      lim <- ia.mask(img[[1]])
    }

    axis(1,c(0.5, lim@w-0.5), labels=c(lim@x, lim@x+lim@w-1))
    axis(2,c(0.5, lim@h-0.5), labels=c(lim@y+lim@h-1, lim@y))
      
  } else {
    if(is.list(img))
      extent <- ia.mask(img[[1]])
    else
      extent <- ia.mask(img)

    plotfunc <- function(lim){
      if(is.null(lim)) {
        img
      } else {
        
        ia.show(ia.get(img, lim))
      
        axis(1,c(0.5, lim@w-0.5), labels=c(lim@x, lim@x+lim@w-1))
        axis(2,c(0.5, lim@h-0.5), labels=c(lim@y+lim@h-1, lim@y))
      
      }
    }

    ia.zoom(plotfunc, extent)
  }
}

