\name{aniOps}

\alias{aniOps}
\alias{aniOp}
\alias{aniGet}
\alias{aniSet}

\title{AnImAl interfaces to low level C-language animage operations}

\description{

Provide  access  to fast  C++ implementations  of \code{animage}  logical,
relational, and arithmetical operations.

}

\usage{
aniOp(img1, op, img2, filter = NULL)

aniGet(img, locus)
aniSet(img, locus, value)
}

\arguments{
   	\item{img, img1}{an \code{animage} object}
	\item{op}{a string with one of the following: \code{+}, \code{-}, \code{*}, \code{/}, \code{MIN}, \code{MAX}, \code{<=}, \code{<}, \code{==}, \code{>},	\code{>=}, \code{&}, \code{|}, \code{^}, \code{!}, \code{<<}, \code{>>}}
	\item{img2}{an \code{animage} object or a scalar numeric value matching the storage mode of \code{img1}}
	\item{filter}{an \code{animask} or an \code{animage} identifying the region where computation will be performed}
	\item{locus}{an \code{animask}, an integer \code{animage}, or a vector of two integers \code{c(x,y)}}
	\item{value}{a scalar numeric value matching the storage mode of \code{img}}
}

\value{

	Function \code{aniOp} returns  a new \code{animage} while function
\code{aniGet}  returns  an  \code{animage}  when  \code{locus}  is  an
\code{animask} or  an \code{animage} and  it returns a  single numeric
value when  \code{locus} is  a vector. Function  \code{aniSet} returns
\code{value}. 

}

\details{
	
	These   R  functions   directly   interface  to   the  C++   level
counterparts. Developers  and users should use  the functions detailed
in   \code{\link{aniOperations}},   typically   characterized   by   a
\code{ia.} prefix,  as they correctly manage the  history mechanism of
\code{animage}  objects.   The  actual  binary operation  selected  by
\code{op}  matches the  corresponding C-language  operator:  the first
argument must be an \code{animage}  while the second argument may be a
scalar (implicitly defining a constant image of infinite extent).

}

\author{Roberto Brunelli \email{brunelli@fbk.eu}}

\seealso{
   \link{aniOperations}
}

\keyword{array}
