\name{ia.eulerNumber}

\alias{ia.eulerNumber}

\title{Euler number}

\description{

  Computes the Euler number for a binary \code{animage}.

}

\usage{ia.eulerNumber(img)}

\arguments{
   	\item{img}{a binary (integer) \code{animage}}
}

\value{
  An integer number.
}

\details{
  
  The  function  computes the image Euler number: the number of
  connected components minus the number of holes. This corresponds to
  the usual definition (the number of vertices plus the number of faces
  minus the number of edges) if we consider (on) pixels as vertices, and
  vertically or horizontally adjacent (on) pixels as edges.

}

\author{Roberto Brunelli \email{brunelli@fbk.eu}}
\references{
  Ming-Hua Chen, Ping-Fan Yan (1988).
  \emph{A fast algorithm to calculate the Euler number for binary images},
  Pattern Recognition Letters 8:295-297
}

\examples{
#
# get paths to package samples
#
sampleimages <- file.path(system.file(package = "AnImAl"), "sampleimages")
#
# Read a couple of sample images
#
tool01 <- ia.readAnimageChannel(file.path(sampleimages,"tool_01.tif"),1)
tool02 <- ia.readAnimageChannel(file.path(sampleimages,"tool_02.tif"),1)
tool01 <- ia.less(tool01, 128L)
tool02 <- ia.less(tool02, 128L)
tool01@outside <- 0L
tool02@outside <- 0L
#
ia.show(tool01)
ia.show(tool02)
#
ia.eulerNumber(tool01)
ia.eulerNumber(tool02)
#
}
\keyword{array}
