\name{ia.localContrast}

\alias{ia.localContrast}

\title{Local contrast operator}

\description{

  Compute the local contrast of a \code{animage} removing linear
  intesity gradients. 

}

\usage{ia.localContrast(img, sigma, norm = 1)}

\arguments{
   	\item{img}{an integer (real) \code{animage}}
	\item{sigma}{a real controlling the }
	\item{norm}{a real}
}

\value{
 An \code{animage}.
}

\details{
  
  The  function divides the original image value by the result of the
  convolution with a Gaussian kernel normalizing the result to the
  interval [0,2*norm] (the result being equal to norm when the
  (original) image value equals the convolved one.

}

\author{Roberto Brunelli \email{brunelli@fbk.eu}}

\examples{
#
# get paths to package samples
#
sampleimages <- file.path(system.file(package = "AnImAl"), "sampleimages")
#
# Read a sample image
#
sampleFace <- as.animage(getChannels(read.pnm(file.path(sampleimages,
"sampleFace_01.pgm"))))
#
# smooth it
#
lcSampleFace <- ia.localContrast(sampleFace, 4.0, 1)
#
# have a look
#
ia.show(lcSampleFace)
#
}
\keyword{array}
