\name{ia.show}

\alias{ia.zoom}
\alias{ia.show}

\title{Simple image visualization}

\description{

  Visualize a single or multi channel animage

}

\usage{

ia.show(img, interactive = FALSE, ...)

}

\arguments{
   	\item{img}{an \code{animage} (or a list of animages)}
	\item{interactive}{a logical: when \code{TRUE}, the user can select
	  an image detail that is then returned by \code{ia.show}}
	\item{...}{arguments passed to the \code{plot} function}
}

\value{

 Function \code{ia.show} returns \code{NULL} when \code{interactive =
   FALSE} or an \code{animage} (or a list of animages representing a
 color image) when \code{interactive = TRUE}.

 
}

\details{

  When \code{interactive = TRUE} the image is presented with axis and
  with a grey background color. When the user selects two points over
  the image, by clicking with  the left mouse button, a new window is
  opened showing the selected bounding box. Clicking over it with the
  right button makes \code{ia.show} return the corresponding image
  region. Left clicking outside the plotting region delimited by the
  axis, discards the current detail.


}

\author{Roberto Brunelli \email{brunelli@fbk.eu}}

\examples{
#
# get paths to package samples
#
sampleimages <- file.path(system.file(package = "AnImAl"), "sampleimages")
#
# Read a sample image
#
sampleFace <- as.animage(getChannels(read.pnm(file.path(sampleimages,
"sampleFace_01.pgm"))))
#
ia.show(sampleFace)
#
# extract a detail from a purple version of the same face
#
# detail <- ia.show(list(sampleFace, ia.div(sampleFace, 2), sampleFace),
#                   interactive = TRUE)
#
# ia.show(detail)
}
\keyword{array}
