#ifndef PNGIO_H
#define PNGIO_H

/*
 *  read png images
 *  based on libpng
 */

#include <arrayTools/Array.h>
#include <arrayTools/namespace_header.h>

namespace _ARRAYTOOLS_NAMESPACE
{
  //READ


  //read graylevel
  //rgb converted
  //alpha channel ingored
  int ReadPng(array<unsigned char>& I, 
	      istream & s);

  int ReadPng(array<unsigned char>& I, 
	      FILE * filestream);

  int ReadPng(array<unsigned char>& I, 
			  const char * filename);

  //read rgb
  //alpha channel ingored
  int ReadPng(array<unsigned char>& R, 
	      array<unsigned char>& G,
	      array<unsigned char>& B,
	      istream & s);

  int ReadPng(array<unsigned char>& R, 
	      array<unsigned char>& G,
	      array<unsigned char>& B,
	      FILE * filestream);

  int ReadPng(array<unsigned char>& R, 
	      array<unsigned char>& G,
	      array<unsigned char>& B,
	      const char * filename);

  //read rgba
  int ReadPng(array<unsigned char>& R, 
	      array<unsigned char>& G,
	      array<unsigned char>& B,
	      array<unsigned char>& A,
	      istream & s);

  int ReadPng(array<unsigned char>& R, 
	      array<unsigned char>& G,
	      array<unsigned char>& B,
	      array<unsigned char>& A,
	      FILE * filestream);

  int ReadPng(array<unsigned char>& R, 
	      array<unsigned char>& G,
	      array<unsigned char>& B,
	      array<unsigned char>& A,
	      const char * filename);


  //WRITE

  int WritePng(array<unsigned char> & I, 
	       ostream & o);

  int WritePng(array<unsigned char> & I, 
	       FILE * filestream);

  int WritePng(array<unsigned char>& I, 
	       char * filename);

  int WritePng(array<unsigned char>& R, 
	       array<unsigned char>& G,
	       array<unsigned char>& B,
	       ostream & o);

  int WritePng(array<unsigned char>& R, 
	       array<unsigned char>& G,
	       array<unsigned char>& B,
	       FILE * filestream);

  int WritePng(array<unsigned char>& R, 
	       array<unsigned char>& G,
	       array<unsigned char>& B,
	       char * filename);

  int WritePng(array<unsigned char>& R, 
	       array<unsigned char>& G,
	       array<unsigned char>& B,
	       array<unsigned char>& A,
	       ostream & o);

  int WritePng(array<unsigned char>& R, 
	       array<unsigned char>& G,
	       array<unsigned char>& B,
	       array<unsigned char>& A,
	       FILE * filestream);

  int WritePng(array<unsigned char>& R, 
	       array<unsigned char>& G,
	       array<unsigned char>& B,
	       array<unsigned char>& A,
	       char * filename);
 
  
}



#endif
