#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <arrayTools/aniCommon.h>
#include <arrayTools/Average.h>

extern "C"  {

  SEXP aniAverage(SEXP animage_1,  // Must be an animage object
				  SEXP r_widthx,   // must be an integer
				  SEXP r_widthy,   // must be an integer 
				  SEXP r_normalize)// must be an integer 
  {
	// Get info on the kernel1
	//
	int widthx    = (INTEGER(r_widthx))[0];
	int widthy    = (INTEGER(r_widthy))[0];
	int normalize = (INTEGER(r_normalize))[0];

	if(TYPEOF(GET_SLOT(animage_1, install("data"))) == INTSXP) 
	  {
		ia::array<int> A = r2ia_ii(animage_1);
	
		A = Average(A, widthx, widthy, normalize);
	
		return(ia2r_ii(A));
	  } else if (TYPEOF(GET_SLOT(animage_1, install("data"))) == REALSXP) {
		ia::array<double> A = r2ia_rd(animage_1);
	
		A = Average(A, widthx, widthy, normalize);
		
		return(ia2r_dr(A));
	  } else {
		return(R_NilValue);
	  }
	
  }
}
