#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <arrayTools/aniCommon.h>
#include <arrayTools/Contrast.h>

extern "C"  {

  SEXP aniLocalContrast(SEXP animage_1, // Must be an animage object
						SEXP r_sigma,   // must be a real 
						SEXP r_norm)    // must be a real 
  {
	// Get info on the kernel1
	//
	double sigma   = (REAL(r_sigma))[0];
	double norm    = (REAL(r_norm))[0];
   
	if(TYPEOF(GET_SLOT(animage_1, install("data"))) == INTSXP) 
	  {
		ia::array<int> A = r2ia_ii(animage_1);
	
		A = Contrast(A, sigma, norm);
	
		return(ia2r_ii(A));
	  } else if (TYPEOF(GET_SLOT(animage_1, install("data"))) == REALSXP) {
		ia::array<double> A = r2ia_rd(animage_1);
	
		A = Contrast(A, sigma, norm);
	
		return(ia2r_dr(A));
	  } else {
		return(R_NilValue);
	  }
	
  }
}
