#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>


#include <R.h>
#include <Rdefines.h>
#include <Rinternals.h>

#include <arrayTools/aniCommon.h>
#include <arrayTools/aniOp.h>
#include <arrayTools/aniOpImmediate.h>


extern "C"  {

  SEXP aniTable(SEXP animage_1,
				SEXP lookup,
				SEXP lookup_o)
  {
	SEXP ani_r;
	int  x1, y1, w1, h1, o1;
	int *p1;
	int *l1;
	int  ol;

    // localize images 
	//
	x1 = GET_ANIMAGE_X(animage_1);
	y1 = GET_ANIMAGE_Y(animage_1);
	w1 = GET_ANIMAGE_W(animage_1);
	h1 = GET_ANIMAGE_H(animage_1);
	o1 = GET_ANIMAGE_O(animage_1);
	p1 = GET_ANIMAGE_D(animage_1);
	
	// Create return animage
	//
	PROTECT(ani_r      = newAnimage(x1, y1, w1, h1, o1));

	// Get info on the look up table
	//
	l1 = INTEGER(lookup);
	ol = INTEGER(lookup_o)[0];

	// Scan data performing substitution
	//
	{
	  int i0 = ol;                      
	  int i1 = LENGTH(lookup);
	  int  n = w1 * h1;

	  while(n--)
		{
		  int v = (*p1) - i0;

		  if(v <= 0)
			*p1 = l1[0];
		  else if (v >= i1) 
			*p1 = l1[i1];
		  else
			*p1 = l1[v];

		  p1++;
		}
	}
	UNPROTECT(1);

	return(ani_r);
  }
}
