#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <arrayTools/aniCommon.h>

extern "C"  {

  SEXP aniTable(SEXP animage_1,
				SEXP lookup,
				SEXP lookup_o)
  {
	SEXP ani_r;
	int  x1, y1, w1, h1, o1;
	int *p1;
	int *pr;
	int *l1;
	int  ol;

    // localize images 
	//
	x1 = GET_ANIMAGE_X(animage_1);
	y1 = GET_ANIMAGE_Y(animage_1);
	w1 = GET_ANIMAGE_W(animage_1);
	h1 = GET_ANIMAGE_H(animage_1);
	o1 = GET_ANIMAGE_OI(animage_1);
	p1 = GET_ANIMAGE_DI(animage_1);
	
	// Create return animage
	//
	PROTECT(ani_r      = newAnimage(x1, y1, w1, h1, o1));

	pr = GET_ANIMAGE_DI(ani_r);

	// Get info on the look up table
	//
	l1 = INTEGER(lookup);
	ol = INTEGER(lookup_o)[0];

	// Scan data performing substitution
	//
	{
	  int i0 = ol;                      
	  int i1 = LENGTH(lookup)-1;
	  int  n = w1 * h1;
	  int  v = o1;

	  while(n--)
		{
		  v = (*p1) - i0;

		  if((v < 0) || (v > i1))
			*pr = *p1;
		  else
			*pr = l1[v];

		  pr++;
		  p1++;
		}

	  // we now 'lookup' the outside value
	  //
	  v = o1 - i0;
	  
	  if((0 <= v) || (v <= i1))
		GET_ANIMAGE_OI(ani_r) = l1[v];
	  else
		GET_ANIMAGE_OI(ani_r) = o1;
	}
	
	UNPROTECT(1);

	return(ani_r);
  }
}
