#
#
#
tm.squareNeighborhood <- function(hl = 1L, pointed = TRUE) {

  N <- c()

  for(j in 1:hl) {
    for(i in 1:hl) {
      N <- c(N, c( i,j))
      N <- c(N, c(-i,j))
      N <- c(N, c(-i,-j))
      N <- c(N, c( i,-j))
    }
  }
  
  for(i in 1:hl) {
    N <- c(N, c( i,0))
    N <- c(N, c(-i,0))
  }
  
  for(j in 1:hl) {
    N <- c(N, c(0, j))
    N <- c(N, c(0,-j))
  }
  
  if(!pointed)
    N <- c(c(0,0), N)
  
  matrix(as.integer(N), ncol=2, byrow=TRUE)
}

#
#
#
tm.ordinalTransform <- function(img,
                                neighborhood,
                                mode = "rank",
                                autoFrame = TRUE)
{
  #
  if(!is.animage(img))
    stop("<img> must be an animage");
  #
  if(!(is.array(neighborhood)      &&
       (dim(neighborhood)[2] == 2) &&
       is.integer(neighborhood)))
    stop("neighborhood must be an integer array with two columns")
  #
  if(!(is.character(mode) &&
       ((mode == "rank")    ||
        (mode == "census")  ||
        (mode == "censusm") ||
        (mode == "ist"))))
    stop("illegal ordinal transform selector")
  #
  res <- .Call("tmOrdinalTransform",
               img,
               neighborhood,
               mode,
               PACKAGE="TeMa")
  #
  if(autoFrame == TRUE)
    res <- ia.frame(res, max(abs(neighborhood)))
  #
  if(is.call(updatedHistory <- ia.updatedHistory(match.call()))) {
    res@history  <- updatedHistory
    res@document <- TRUE
  } else {
    res@history  <- call("<undef>")
    res@document <- FALSE
  }
  #
  res
}
