ia.cooccurrence <- function(img,
                            dx = 1L,
                            dy = 1L,
                            decimation = 32L) {
  
  # we must also check for the image to be integer
  #
  if(!(is.animage(img) && (img@storage == "integer")))
    stop("'img' must be an integer animage")
  
  if(!(is.integer(dx)))
    stop("'dx' must be an integer scalar")

  if(!(is.integer(dy)))
    stop("'dy' must be an integer scalar")

  data        <- ia.div(img, decimation)@data
  maxvalue    <- max(max(data), img@outside)
  cooccurence <- array(0, c(maxvalue, maxvalue))

  x0          <- img@focus[1]
  y0          <- img@focus[2]
  x1          <- x0 + dim(data)[2] - 1
  y1          <- y0 + dim(data)[1] - 1
  
  for(y in seq(y0, y1)) {
    for(x in seq(x0, x1)) {
      v1 <- data[y,x]
      v2 <- data[y+dy, x+dx]
      cooccurence[v1,v2] <- cooccurence[v1,v2] + 1
    }
  }

  cooccurence
}
