require(corpcor)

tm.shrinkageAdvantage <- function(ps, ns, ne = 3, ss = 3) {
  r <- length(ns)
  c <- length(ps)

  d1 <- array(0, dim = c(r,c))
  d2 <- array(0, dim = c(r,c))

  for(s in 1:ss) {
    message(".", appendLF = FALSE)
    pi <- 1
    for(p in ps) {
      #
      # generate a random covariance matrix
      #
      sigma  <- matrix(rnorm(p*p),ncol=p)
      sigma  <- crossprod(sigma)+ diag(rep(0.01, p))
      sigsvd <- svd(sigma)
      #
      ni <- 1
      for(n in ns) {
        #
        # for each cardinality perform
        # multiple experiments to compute  the average
        # estimation error
        #
        a1 <- 0
        a2 <- 0
        for(e in 1:ne) {
          #
          # generating the required number of samples,
          #
          Y <- t(sigsvd$v %*% (t(sigsvd$u) * sqrt(sigsvd$d)))
          X <- matrix(rnorm(n * ncol(sigma)), nrow = n) %*% Y
          #
          # estimate covariance matrix in two different ways
          #
          s1 <- cov(X)
          s2 <- cov.shrink(X, protect=0, verbose=FALSE)
          #
          # compute the errors
          #
          d1[ni,pi] <- d1[ni,pi] + sum((s1-sigma)^2)
          d2[ni,pi] <- d2[ni,pi] + sum((s2-sigma)^2)
        }
        ni        <- ni + 1
      }
      pi <- pi+1
    }
  }
  list(d1, d2)
}
